/*
  Copyright (C) 2000-2003 SKYRIX Software AG

  This file is part of OGo

  OGo is free software; you can redistribute it and/or modify it under
  the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version.

  OGo is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
  License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with OGo; see the file COPYING.  If not, write to the
  Free Software Foundation, 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.
*/
// $Id: LSWContentPage.h,v 1.2 2003/07/11 16:46:01 jan Exp $

#ifndef __LSWebInterface_LSOffice3_LSWFoundation_LSWContentPage_H__
#define __LSWebInterface_LSOffice3_LSWFoundation_LSWContentPage_H__

#include <OGoFoundation/LSWComponent.h>
#include <LSFoundation/LSCommand.h>

/*
  
  KVC:
    confirmString: --> confirm message
    confirmAction: --> confirm action
    
*/

@class NSString;
@class NGHashMap;
@class WOContext;
@class LSWNavigation;

@protocol LSWContentPage < NSObject >

- (NSString *)label;
- (BOOL)rollbackForPage:(id<LSWContentPage>)_page;

@end

@interface LSWContentPage : LSWComponent < LSWContentPage >
{
@private
  NSString *warningOkAction;
  NSString *warningPhrase;
  BOOL     isInWarningMode;
  NSString *errorString;
}

- (LSWNavigation *)navigation;

- (void)setIsInWarningMode:(BOOL)_isInWarningMode;
- (BOOL)isInWarningMode;
- (void)setWarningPhrase:(NSString *)_phrase;
- (NSString *)warningPhrase;
- (void)setWarningOkAction:(NSString *)_warningOkAction;
- (NSString *)warningOkAction;

/* notifications */

- (void)noteChange:(NSString *)_changeName onObject:(id)_object;
- (void)postChange:(NSString *)_changeName onObject:(id)_object;
- (void)postChange:(NSString *)_changeName;

- (void)registerForNotificationNamed:(NSString *)_notificationName
  object:(id)_object;
- (void)registerForNotificationNamed:(NSString *)_notificationName;
- (void)unregisterAsObserver;

/* component activation */

- (BOOL)executePasteboardCommand:(NSString *)_command;

/* errors */

- (void)setErrorString:(NSString *)_error;
- (void)setErrorCString:(const char *)_error;
- (NSString *)errorString;
- (void)resetErrorString;
- (BOOL)hasErrorString;

@end

@class NGMimeType;

@interface WOComponent(LSWActivationComponent)

- (BOOL)prepareForActivationCommand:(NSString *)_name
  type:(NGMimeType *)_type;
- (BOOL)prepareForActivationCommand:(NSString *)_name
  type:(NGMimeType *)_type
  configuration:(NSDictionary *)_config;
- (BOOL)prepareForActivationCommand:(NSString *)_name
  type:(NGMimeType *)_type
  object:(id)_object;

@end

@interface NSObject(ContentPageTyping)
- (BOOL)isContentPage;
@end

#include <OGoFoundation/WOComponent+Navigation.h>

#endif /* __LSWebInterface_LSOffice3_LSWFoundation_LSWContentPage_H__ */
