/*
  Copyright (C) 2000-2003 SKYRIX Software AG

  This file is part of OGo

  OGo is free software; you can redistribute it and/or modify it under
  the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version.

  OGo is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
  License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with OGo; see the file COPYING.  If not, write to the
  Free Software Foundation, 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.
*/
// $Id: LSWNavigation.h,v 1.2 2003/07/11 16:46:01 jan Exp $

#ifndef __LSWFoundation_LSWNavigation_H__
#define __LSWFoundation_LSWNavigation_H__

#import <Foundation/NSObject.h>
#import <NGObjWeb/WOActionResults.h>

@class NSMutableArray, NSArray, NSString;
@class LSWSession, LSWContentPage;

@interface LSWNavigation : NSObject < WOActionResults >
{
@private
  LSWSession     *session; // non-retained
  struct {
    LSWContentPage **elements;
    short index;
    short count;
    short size;
  } pages;
}

- (id)initWithSession:(LSWSession *)_sn;

/* query */

- (id)activePage;
- (NSArray *)pageStack;
- (BOOL)containsPages;

/* actions */

- (void)enterPage:(id)_page;
- (id)leavePage;

@end

@interface LSWNavigation(Activation)

- (id)activateObject:(id)_object withVerb:(NSString *)_verb;

@end

#endif /* __LSWFoundation_LSWNavigation_H__ */
